<template>
  <div>
    <v-alert
      :value="alert"
      @click="alert = !alert"
      icon="mdi-alert-outline"
      dense
      dark
      border="left"
      type="warning"
      transition="scale-transition"
    >
      Has recibido nuevos documentos por firmar
    </v-alert>
    <div class="gris">
      <v-data-table
        :headers="headers"
        :items="data"
        :page.sync="page"
        :items-per-page="itemsPerPage"
        item-key="idFolio"
        :loading="loading"
        :height="350"
        :dense="true"
        :fixed-header="true"
        class="custom-table"
        @page-count="pageCount = $event"
        hide-default-footer
      >
        <template v-slot:item.documento.titulo="{ item }">
          <router-link
            :class="{ 'new-notify': !item.visualizado }"
            class="link"
            :to="to(item)"
          >
            {{ item.documento.titulo }}
          </router-link>
        </template>
        <template v-slot:item.idFolio="{ item }">
          <span :class="{ 'new-notify': !item.visualizado }">
            {{ item.idFolio }}
          </span>
        </template>
        <template v-slot:item.creador.nombre="{ item }">
          <span :class="{ 'new-notify': !item.visualizado }">
            {{ item.creador.nombre }}
          </span>
        </template>
        <template v-slot:item.fechaCreacion="{ item }">
          <span :class="{ 'new-notify': !item.visualizado }">
            {{ fechaFormat(item.fechaCreacion) }}
          </span>
        </template>
        <template
          v-slot:item.fechaSolicitud="{ item }"
          :class="{ 'new-notify': !item.visualizado }"
        >
          <span :class="{ 'new-notify': !item.visualizado }">
            {{ fechaFormat(item.fechaSolicitud) }}
          </span>
        </template>
        <template
          v-slot:item.detalle="{ item }"
          :class="{ 'new-notify': !item.visualizado }"
        >
          <span :class="{ 'new-notify': !item.visualizado }">
            <router-link class="link" :to="to(item)"> Ver detalle </router-link>
          </span>
          <v-icon>mdi-eye-outline</v-icon>
        </template>
        <template
          v-slot:item.estado.descripcion="{ item }"
          :class="{ 'new-notify': !item.visualizado }"
        >
          <span
            :class="[
              classEstado(item.estado.idEstadoFolio),
              ...{ 'new-notify': !item.visualizado },
            ]"
            >{{ item.estado.descripcion }}</span
          >
        </template>
        <template
          v-slot:item.unidadesNegocio="{ item }"
          :class="{ 'new-notify': !item.visualizado }"
        >
          <template v-if="item.unidadesNegocio.length > 0">
            <template v-if="item.unidadesNegocio.length == 1">
              <span :class="{ 'new-notify': !item.visualizado }">
                {{ item.unidadesNegocio[0].descripcion }}
              </span>
            </template>
            <template v-else>
              <div class="mt-2" style="display: inline-block">
                <span :class="{ 'new-notify': !item.visualizado }">
                  {{ item.unidadesNegocio[0].descripcion }}
                </span>
              </div>
              <v-menu bottom left>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn
                    class="float-rigth"
                    right
                    fab
                    dark
                    x-small
                    dense
                    :elevation="0"
                    color="grey"
                    v-bind="attrs"
                    v-on="on"
                  >
                    <v-icon>mdi-dots-vertical</v-icon>
                  </v-btn>
                </template>
                <v-list>
                  <template
                    v-for="(itemUnidadNegocio, i) in item.unidadesNegocio"
                  >
                    <v-list-item v-if="i > 0" :key="i">
                      <v-list-item-title>{{
                        itemUnidadNegocio.descripcion
                      }}</v-list-item-title>
                    </v-list-item>
                  </template>
                </v-list>
              </v-menu>
            </template>
          </template>
          <template v-else>
            <span
              :class="{ 'new-notify': !item.visualizado }"
              class="text--disabled"
              >N/A</span
            >
          </template>
        </template>
        <template v-slot:footer="{ props }">
          <div
            v-if="data.length > 0"
            class="pa-2 t-footer"
            style="height: 60px"
          >
            <div style="float: left">
              Se muestra del {{ props.pagination.pageStart + 1 }} al
              {{ props.pagination.pageStop }} de un total de
              {{ props.pagination.itemsLength }}
            </div>
            <v-pagination
              style="float: right"
              v-model="page"
              :length="props.pagination.pageCount"
              :total-visible="props.pagination.itemsPerPage"
            ></v-pagination>
          </div>
        </template>
      </v-data-table>
    </div>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
.new-notify {
  font-family: "Avenir_Next_Demi_Bold";
  font-style: italic;
  font-weight: bolder;
  font-size: smaller;
}
</style>
<script>
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
import moment from "moment";
export default {
  name: "Component-TablaFoliosUsuario",
  data: (vm) => ({
    data: [],
    pageCount: null,
    page: 1,
    itemsPerPage: 5,
    loading: false,
    alert: false,
    headers: [
      {
        text: "Folio",
        value: "idFolio",
        align: "center",
      },
      { text: "Documento", value: "documento.titulo", align: "center" },
      {
        text: "Unidad(es) de Negocio",
        value: "unidadesNegocio",
        align: "center",
      },
      { text: "Documentador", value: "creador.nombre", align: "center" },
      { text: "Estado", value: "estado.descripcion", align: "center" },
      { text: "Fecha de creación", value: "fechaCreacion", align: "center" },
      {
        text: "Fecha de solicitud",
        value: "fechaSolicitud",
        align: "center",
      },
      { text: "Detalle", value: "detalle", align: "center", sortable: false },
    ],
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    empleadoLogued() {
      return serviceLocalStorage.userToken();
    },
  },
  methods: {
    newNotifications() {
      this.alert = !(this.data.filter((item) => item.visualizado).length > 0);
    },
    to(folio) {
      return {
        name: "modelo_negocio_bandeja_autorizacion_detalle_folio",
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
            documento: {
              titulo: folio.documento.titulo,
            },
            estado: folio.estado,
            visualizado: folio.visualizado,
            firma: {
              idFirma: folio.firma.idFirma,
            },
          }),
        },
      };
    },
    classEstado(idEstadoFolio) {
      if (idEstadoFolio == 2) {
        return { "documentar--text": true };
      }
      if (idEstadoFolio == 3) {
        return { "revisar--text": true };
      }
      if (idEstadoFolio == 4) {
        return { "autorizar--text": true };
      }
      if (idEstadoFolio == 5) {
        return { "publicado--text": true };
      }
    },
    getFoliosUsuarioBusquedas() {
      const self = this;
      this.loading = true;
      axios(
        "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.empleadoLogued.empleado +
          "/documentos/autorizacion"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.data = data.resultado.folios;
            self.newNotifications();
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
    fechaFormat(fechaIn) {
      if (fechaIn) {
        fechaIn = fechaIn.substr(0, 10);
        let parts_of_date = fechaIn.split("/");
        let output = new Date(
          +parts_of_date[2],
          parts_of_date[1] - 1,
          +parts_of_date[0]
        );
        let fecha = moment(output).format("DD/MM/yyyy");
        return fecha;
      } else {
        return null;
      }
    },
  },
  created() {
    this.getFoliosUsuarioBusquedas();
  },
};
</script>
